%global pkg mptsas

%global driver_version 5.14.0-79.el9

%global kernel_version 5.14.0-83.el9

%global debug_package %{nil}

%global __spec_install_post \
  %{?__debug_package:%{__debug_install_post}} \
  %{__arch_install_post} \
  %{__os_install_post} \
  %{__mod_compress_install_post}

%global __mod_compress_install_post find %{buildroot}/lib/modules -type f -name \*.ko -exec xz \{\} \\;


Name:             kmod-%{pkg}
Version:          5.14.0.79
Release:          2%{?dist}
Summary:          Fusion MPT SAS Host (%{pkg}) driver

License:          GPLv2
URL:              https://www.kernel.org/

Source0:          %{pkg}-%{driver_version}.tar.xz
Patch1:           0001-add-deprecated-ids.patch
Patch2:           0002-remove-unsupported-warning.patch

ExclusiveArch:    x86_64 aarch64 ppc64le

BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kernel-rpm-macros
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    redhat-rpm-config
BuildRequires:    xz

BuildRequires:    kernel-abi-stablelists = %{kernel_version}
BuildRequires:    kernel-devel = %{kernel_version}
BuildRequires:    kernel-devel-uname-r = %{kernel_version}.%{_arch}

Requires:         kernel >= %{kernel_version}
Requires:         kernel-uname-r >= %{kernel_version}.%{_arch}
Requires:         kernel-modules >= %{kernel_version}
Requires:         kernel-modules-uname-r >= %{kernel_version}.%{_arch}

Provides:         installonlypkg(kernel-module)
Provides:         kernel-modules >= %{kernel_version}.%{_arch}

Requires(post):   %{_sbindir}/depmod
Requires(postun): %{_sbindir}/depmod

Requires(post):   %{_sbindir}/weak-modules
Requires(postun): %{_sbindir}/weak-modules


%if "%{version}" == "5.14.0.1" && "%{release}" == "10%{?dist}"
Obsoletes:        kmod-%{pkg} = %{?epoch:%{epoch}:}%{version}-9%{?dist}
%endif


%description
This package provides the Fusion MPT SAS Host (%{pkg}) driver.  Compared to the
in-kernel driver this driver is not restricted to the virtualization use case.
It supports the following adapters:

- 0x1000:0x0050: LSI SAS1064
- 0x1000:0x0054: LSI SAS1068
- 0x1000:0x0056: LSI SAS1064E
- 0x1000:0x0058: LSI SAS1068E
- 0x1000:0x0059: LSI SAS1068_820XELP
- 0x1000:0x0062: LSI SAS1078


%prep
%autosetup -p1 -n %{pkg}-%{driver_version}


%build
pushd src
%{__make} -C /usr/src/kernels/%{kernel_version}.%{_arch} %{?_smp_mflags} M=$PWD modules
popd


%install
%{__install} -D -t %{buildroot}/lib/modules/%{kernel_version}.%{_arch}/extra/drivers/message/fusion src/%{pkg}.ko

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel_version}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done


%clean
%{__rm} -rf %{buildroot}


%post
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
printf '%s\n' "/lib/modules/%{kernel_version}.%{_arch}/extra/drivers/message/fusion/%{pkg}.ko.xz" >> %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-add


%preun
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
rpm -ql kmod-%{pkg}-%{?epoch:%{epoch}:}%{version}-%{release}.%{_arch} | grep '/lib/modules/%{kernel_version}.%{_arch}/.*\.ko\.xz$' >> %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-remove


%postun
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-remove ]
then
    modules=( $(cat %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-remove) )
    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-remove
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
    printf '%s\n' "${modules[@]}" | %{_sbindir}/weak-modules --remove-modules
fi


%pretrans -p <lua>
posix.unlink("%{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-add")
posix.unlink("%{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-remove")


%posttrans
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-add ]
then
    modules=( $(cat %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-add) )
    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/weak-modules-add
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
    printf '%s\n' "${modules[@]}" | %{_sbindir}/weak-modules --add-modules
fi


%files
%defattr(644,root,root,755)
/lib/modules/%{kernel_version}.%{_arch}
%license LICENSES
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf


%changelog
* Thu May 26 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.79-2
- Rebuild for 5.14.0-83.el9

* Fri Apr 22 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.79-1
- Update to 5.14.0-79.el9

* Wed Apr 13 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-9
- Rebuild for 5.14.0-78.el9

* Tue Apr 12 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-8
- Rebuild for 5.14.0-77.el9

* Mon Mar 28 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-7
- Rebuild for 5.14.0-75.el9

* Tue Mar 22 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-6
- Rebuild for 5.14.0-73.el9

* Thu Feb 24 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-5
- Rebuild for 5.14.0-65.el9

* Sun Feb 20 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-4
- Rebuild for 5.14.0-62.el9

* Fri Feb 18 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-3
- Rebuild for 5.14.0-60.el9

* Tue Feb 15 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-2
- Rebuild for 5.14.0-58.el9

* Sat Feb 12 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.57-1
- Update to 5.14.0-57.el9

* Thu Feb 10 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-15
- Rebuild for 5.14.0-56.el9

* Mon Feb 07 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-14
- Rebuild for 5.14.0-55.el9

* Wed Feb 02 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-13
- Rebuild for 5.14.0-51.el9

* Thu Jan 27 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-12
- Rebuild for 5.14.0-48.el9

* Tue Jan 25 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-11
- Rebuild for 5.14.0-47.el9

* Wed Jan 19 2022 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.14.0.1-10
- Enable ppc64le

* Wed Jan 19 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-9
- Rebuild for 5.14.0-44.el9

* Tue Jan 18 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-8
- Rebuild for 5.14.0-43.el9

* Mon Jan 17 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-7
- Rebuild for 5.14.0-42.el9

* Fri Jan 14 2022 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-6
- Rebuild for 5.14.0-41.el9

* Sat Dec 25 2021 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-5
- Rebuild for 5.14.0-39.el9
- Skip unreleased kernel -38

* Thu Dec 23 2021 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-4
- Rebuild for 5.14.0-37.el9

* Wed Dec 22 2021 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-3
- Rebuild for 5.14.0-36.el9

* Wed Dec 22 2021 Kmods SIG <sig-kmods@centosproject.org> - 5.14.0.1-2
- Rebuild for 5.14.0-34.el9
- Skip unreleased kernel -32 and -33

* Thu Dec 16 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.14.0.1-1
- Convert to kABI tracking kmod package (kernel >= 5.14.0-31.el9)
